## taisei 1.4.1+dfsg

=== meson_options.txt ===

option(
    'developer',
    type : 'combo',
    choices : ['true', 'false', 'auto'],
    value : 'false',
    deprecated : ['auto'],
    description : 'Make a "developer" build with cheats and extra debugging features'
)

option('vfs_zip',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Support loading of game data from ZIP packages (requires libzip)'
)

option(
    'enable_zip',
    type : 'boolean',
    deprecated : 'vfs_zip',
    description : 'DEPRECATED: use vfs_zip instead',
)

option(
    'package_data',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Package the game’s assets into a compressed archive (requires vfs_zip)'
)

option(
    'install_relocatable',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Install everything into the same directory, don\'t hardcode absolute paths into the executable. Prefix is assumed to be an empty directory reserved for Taisei in this mode.'
)

option(
    'install_relative',
    type : 'combo',
    choices : ['auto', 'true', 'false'],
    deprecated : 'install_relocatable',
    description : 'DEPRECATED: use install_relocatable instead',
)

option(
    'install_freedesktop',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Install freedesktop.org integration files (launchers, icons, replay file associations, etc.). Mostly relevant for Linux/BSD/etc. desktop systems'
)

option(
    'install_macos_bundle',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'auto', 'false' : 'disabled'},
    description : 'Install into a macOS application bundle'
)

option(
    'macos_bundle',
    type : 'boolean',
    deprecated : 'install_macos_bundle',
    description : 'DEPRECATED: use install_macos_bundle instead',
)

option(
    'install_angle',
    type : 'boolean',
    value : false,
    description : 'Install pre-built ANGLE libraries. Required for Windows/macOS OpenGL ES 2.0/3.0'
)

option(
    'angle_libgles',
    type : 'string',
    description : 'Path to ANGLE\'s libGLESv2 dynamic library (see install_angle)'
)

option(
    'angle_libegl',
    type : 'string',
    description : 'Path to ANGLE\'s libEGL dynamic library (see install_angle)'
)

option(
    'win_console',
    type : 'boolean',
    value : false,
    description : 'Use the console subsystem on Windows'
)

option(
    'static',
    type : 'boolean',
    value : false,
    deprecated : 'prefer_static',
    description : 'DEPRECATED: use prefer_static instead',
)

option(
    'docs',
    type : 'feature',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Build and install documentation (requires docutils)'
)

option(
    'shader_transpiler',
    type : 'feature',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Enable shader trans-compilation (requires shaderc)'
)

option(
    'validate_glsl',
    type : 'feature',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Enable validation of GLSL shaders (requires glslc)'
)

option(
    'r_default',
    type : 'combo',
    choices : ['auto', 'gl33', 'gles20', 'gles30', 'null'],
    description : 'Which rendering backend to use by default'
)

option(
    'r_gl33',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Build the OpenGL 3.3 Core renderer'
)

option(
    'r_gles20',
    type : 'feature',
    value : 'disabled',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Build the OpenGL ES 2.0 renderer (incomplete)'
)

option(
    'r_gles30',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Build the OpenGL ES 3.0 renderer'
)

option(
    'r_null',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Build the no-op renderer (nothing is displayed). Required for --verify-replay to work properly'
)

option(
    'a_default',
    type : 'combo',
    choices : ['auto', 'sdl', 'null'],
    description : 'Which audio backend to use by default'
)

option(
    'a_sdl',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Build the SDL audio backend'
)

option(
    'a_null',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Build the no-op audio backend (silence); you want this on!'
)

option(
    'use_libcrypto',
    type : 'feature',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Use libcrypto from OpenSSL for better SHA implementations'
)

option(
    'deprecation_warnings',
    choices : ['default', 'error', 'no-error', 'ignore'],
    type : 'combo',
    description : 'Treatment of deprecation warnings'
)

option(
    'force_vendored_shader_tools',
    type : 'boolean',
    value : false,
    description : 'Build shaderc and spirv-cross CLI tools from subprojects even if system versions exist'
)

option(
    'stages_live_reload',
    type : 'boolean',
    value : false,
    description : 'Enable live-reloading workflow for stages (for development only)'
)

option(
    'gamemode',
    type : 'feature',
    description: 'Integrate with the GameMode daemon, if running'
)

=== external/basis_universal/meson_options.txt ===

option(
    'enable_astc',
    type : 'boolean',
    value : true,
    description : 'Enable transcoding into ASTC (mobile, Intel devices, hopefully all desktop GPUs one day)'
)

option(
    'enable_atc',
    type : 'boolean',
    value : false,
    description : 'Enable transcoding into ATC (mobile, Adreno devices, this is a niche format)'
)

option(
    'enable_bc7',
    type : 'boolean',
    value : true,
    description : 'Enable transcoding into BC7 (desktop, some mobile devices)'
)

option(
    'enable_dxt1',
    type : 'boolean',
    value : true,
    description : 'Enable transcoding into DXT1'
)

option(
    'enable_dxt5a',
    type : 'boolean',
    value : true,
    description : 'Enable transcoding into DXT5A'
)

option(
    'enable_etc2_eac_a8',
    type : 'boolean',
    value : true,
    description : 'Enable transcoding into ETC2_EAC_A8'
)

option(
    'enable_etc2_eac_rg11',
    type : 'boolean',
    value : true,
    description : 'Enable transcoding into ETC2_EAC_RG11 and ETC2_EAC_R11'
)

option(
    'enable_fxt1',
    type : 'boolean',
    value : false,
    description : 'Enable transcoding into FXT1 (desktop, Intel devices, this is a super obscure format)'
)

option(
    'enable_pvrtc1',
    type : 'boolean',
    value : false,
    description : 'Enable transcoding into PVRTC1 (mobile, PowerVR devices, pow2 textures only)'
)

option(
    'enable_pvrtc2',
    type : 'boolean',
    value : true,
    description : 'Enable transcoding into PVRTC2 (mobile, PowerVR devices)'
)

option(
    'enable_uastc',
    type : 'boolean',
    value : true,
    description : 'Enable transcoding of UASTC source files'
)

option(
    'enable_ktx2',
    type : 'boolean',
    value : true,
    description : 'Enable KTX2 container support in the transcoder'
)

option(
    'enable_ktx2_zstd',
    type : 'boolean',
    value : true,
    description : 'Enable support for Zstandard-compressed KTX2 files in the transcoder'
)

=== external/koishi/meson_options.txt ===
option(
    'impl',
    type : 'combo',
    choices : [
        'auto',
        'fcontext',
        'boost_fcontext',
        'win32fiber',
        'emscripten',
        'ucontext_e2k',
        'ucontext',
        'ucontext_sjlj',
    ],
    description : 'Which implementation to use'
)

option(
    'threadsafe',
    type : 'boolean',
    value : true,
    description : 'Whether multiple coroutines can be ran on different threads at once (needs compiler support)'
)

option(
    'valgrind',
    type : 'boolean',
    value : false,
    description : 'Enable support for running under Valgrind (for debugging)'
)

=== misc/ci/Makefile ===
# Taisei Docker Makefile

tag:
ifndef TAG
	@echo "tag not defined, please define one"
	@echo "i.e: TAG=20210630 make docker/switch"
	@exit 1
endif

##########
# docker #
##########

docker/windows: tag
	docker build . -m 8GB -t taiseiproject/windows-toolkit:$(TAG) -f "Dockerfile.windows"
	docker push taisei/windows-toolkit:$(TAG)

docker/switch: tag
	docker build . -m 4GB -t taiseiproject/switch-toolkit:$(TAG) -f "Dockerfile.switch"
	docker push taiseiproject/switch-toolkit:$(TAG)

docker/linux: tag
	docker build . -m 4GB -t taiseiproject/linux-toolkit:$(TAG) -f "Dockerfile.linux"
	docker push taiseiproject/linux-toolkit:$(TAG)

=== debian/changelog ===
taisei (1.4.1+dfsg-2) unstable; urgency=low

  * Suorce-only upload.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Sun, 16 Mar 2025 07:51:21 +0800

taisei (1.4.1+dfsg-1) unstable; urgency=low

  * Initial release. (Closes: #1083093)

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Mon, 07 Oct 2024 05:40:18 +0800

=== debian/control ===
Source: taisei
Section: games
Priority: optional
Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               docbook-xsl,
               gamemode-dev,
               libcglm-dev,
               libfreetype-dev,
               libopusfile-dev,
               libpng-dev,
               libsdl2-dev,
               libsdl2-mixer-dev,
               libssl-dev,
               libwebp-dev,
               libzip-dev,
               libzstd-dev,
               meson,
               ninja-build,
               ocl-icd-opencl-dev,
               python3,
               python3-docutils,
               python3-zstandard,
               xsltproc,
               zlib1g-dev
Standards-Version: 4.7.0
Homepage: https://taisei-project.org/

Package: taisei
Architecture: any
Depends: taisei-data, ${misc:Depends}, ${shlibs:Depends}
Description: vertical scrolling shooting game
 Taisei Project is an open source fan-game set in the world of Toho Project.
 It is a top-down vertical-scrolling curtain fire shooting game (STG), also
 known as a "bullet hell" or "danmaku." STGs are fast-paced games focused
 around pattern recognition and mastery through practice.

Package: taisei-data
Architecture: all
Depends: ${misc:Depends}
Description: vertical scrolling shooting game (data files)
 Taisei Project is an open source fan-game set in the world of Toho Project.
 It is a top-down vertical-scrolling curtain fire shooting game (STG), also
 known as a "bullet hell" or "danmaku." STGs are fast-paced games focused
 around pattern recognition and mastery through practice.
 .
 This package contains the main data files required for taisei

=== debian/watch ===
# Compulsory line, this is a version 4 file.
version=4

GitHub hosted projects.
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%, repacksuffix=+dfsg, dversionmangle=auto, repack,compression=xz" \
    https://github.com/taisei-project/taisei/releases \
    (?:.*?/)taisei-@ANY_VERSION@@ARCHIVE_EXT@

## taisei 1.4.4%2Bdfsg

=== meson_options.txt ===
--- 
+++ 
@@ -1,3 +1,11 @@
+
+option(
+    'allocator',
+    type  : 'combo',
+    choices : ['libc', 'mimalloc', 'auto'],
+    value : 'auto',
+    description : 'Which memory allocator to use'
+)
 
 option(
     'developer',
@@ -114,7 +122,14 @@
     'shader_transpiler',
     type : 'feature',
     deprecated : {'true' : 'enabled', 'false' : 'disabled'},
-    description : 'Enable shader trans-compilation (requires shaderc)'
+    description : 'Enable shader trans-compilation (requires glslang)'
+)
+
+option(
+    'shader_transpiler_dxbc',
+    type : 'feature',
+    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
+    description : 'Enable compilation of shaders into DXBC bytecode; required for the D3D11 backend of SDL_GPU'
 )
 
 option(
@@ -127,7 +142,7 @@
 option(
     'r_default',
     type : 'combo',
-    choices : ['auto', 'gl33', 'gles20', 'gles30', 'null'],
+    choices : ['auto', 'gl33', 'gles30', 'sdlgpu', 'null'],
     description : 'Which rendering backend to use by default'
 )
 
@@ -140,19 +155,19 @@
 )
 
 option(
-    'r_gles20',
-    type : 'feature',
-    value : 'disabled',
-    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
-    description : 'Build the OpenGL ES 2.0 renderer (incomplete)'
-)
-
-option(
     'r_gles30',
     type : 'feature',
     value : 'auto',
     deprecated : {'true' : 'enabled', 'false' : 'disabled'},
     description : 'Build the OpenGL ES 3.0 renderer'
+)
+
+option(
+    'r_sdlgpu',
+    type : 'feature',
+    value : 'auto',
+    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
+    description : 'Build the SDL3 GPU renderer'
 )
 
 option(
@@ -204,7 +219,7 @@
     'force_vendored_shader_tools',
     type : 'boolean',
     value : false,
-    description : 'Build shaderc and spirv-cross CLI tools from subprojects even if system versions exist'
+    description : 'Build glslang and spirv-cross CLI tools from subprojects even if system versions exist'
 )
 
 option(
@@ -219,3 +234,9 @@
     type : 'feature',
     description: 'Integrate with the GameMode daemon, if running'
 )
+
+option(
+    'tests',
+    type : 'feature',
+    description : 'Build various test programs'
+)

=== external/basis_universal/CMakeLists.txt ===
# Important: The Basis Universal encoder and transcoder libraries must be compiled with -fno-strict-aliasing (MSVC's default, and also the Linux kernel).
# It should also work without this option, but we do not test with it.
cmake_minimum_required(VERSION 3.5)

project(basisu)
option(STATIC "static linking" FALSE)
option(SAN "sanitize" FALSE)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)

# For MSVC builds default to SSE enabled, and determine if it's a 64-bit (-A x64) vs. 32-bit (-A Win32) build.
if (MSVC)
    option(SSE "SSE 4.1 support" TRUE)
    if ( CMAKE_GENERATOR_PLATFORM STREQUAL Win32 )    
        set(BUILD_X64 0)
    else()
        set(BUILD_X64 1)
    endif()
	add_compile_options(/W4)
else()
    option(SSE "SSE 4.1 support" FALSE)
    option(BUILD_X64 "build 64-bit" TRUE)
endif()

option(ZSTD "ZSTD support for KTX2 transcoding/encoding" TRUE)
option(OPENCL "OpenCL support in encoder" FALSE)

message("Initial BUILD_X64=${BUILD_X64}")
message("Initial CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
message("Initial SSE=${SSE}")
message("Initial ZSTD=${ZSTD}")
message("Initial OPENCL=${OPENCL}")
message("Initial SAN=${SAN}")

if ((NOT MSVC) AND OPENCL)
    # With MSVC builds we use the Khronos lib/include files in the project's "OpenCL" directory, to completely avoid requiring fiddly to install vendor SDK's.
    # Otherwise we use the system's (if any).
    find_package(OpenCL)
    message(STATUS "OpenCL found: ${OPENCL_FOUND}")
    message(STATUS "OpenCL includes: ${OpenCL_INCLUDE_DIRS}")
    message(STATUS "OpenCL libraries: ${OpenCL_LIBRARIES}")
endif()

if( NOT CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release )
endif()

message(${PROJECT_NAME} " build type: " ${CMAKE_BUILD_TYPE})

if (BUILD_X64)
    message("Building 64-bit")
else()
    message("Building 32-bit")
endif()

if (SSE)
    message("SSE enabled")
else()
    message("SSE disabled")
endif()

if (ZSTD)
    message("Zstandard enabled")
else()
    message("Zstandard disabled")
endif()

if (NOT MSVC)
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -g")
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -g")
   
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")
    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")

    if (SAN)
		message("Enabling SAN")
		
		  set(SANITIZE_FLAGS "-fsanitize=address -fno-omit-frame-pointer -fsanitize=undefined -fno-sanitize=alignment")
		
		  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${SANITIZE_FLAGS}")
        set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} ${SANITIZE_FLAGS}")
	
        set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${SANITIZE_FLAGS}")
        set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} ${SANITIZE_FLAGS}")
    endif()

    set(CMAKE_CXX_FLAGS -std=c++17)
    set(GCC_COMPILE_FLAGS "-fvisibility=hidden -fPIC -fno-strict-aliasing -D_LARGEFILE64_SOURCE=1 -D_FILE_OFFSET_BITS=64 -Wall -Wextra -Wno-unused-local-typedefs -Wno-unused-value -Wno-unused-parameter -Wno-unused-variable -Wno-reorder -Wno-misleading-indentation -Wno-class-memaccess -Wno-deprecated-copy -Wno-maybe-uninitialized -Wno-unused-function -Wno-stringop-overflow -Wno-unknown-warning-option")
   
    if (NOT BUILD_X64)
        set(GCC_COMPILE_FLAGS "${GCC_COMPILE_FLAGS} -m32")
    endif()

    if (EMSCRIPTEN)
        set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -s ALLOW_MEMORY_GROWTH=1 -DBASISU_SUPPORT_SSE=0")
        set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -s ALLOW_MEMORY_GROWTH=1 -DBASISU_SUPPORT_SSE=0")

        set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} ${GCC_LINK_FLAGS}")
    elseif (STATIC)
        if (SSE)
            set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DBASISU_SUPPORT_SSE=1 -msse4.1")
            set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DBASISU_SUPPORT_SSE=1 -msse4.1")
        else()
            set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DBASISU_SUPPORT_SSE=0")
            set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DBASISU_SUPPORT_SSE=0")
        endif()
      
        set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} ${GCC_LINK_FLAGS} -static-libgcc -static-libstdc++ -static")
    else()
        if (SSE)
            set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DBASISU_SUPPORT_SSE=1 -msse4.1")
            set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DBASISU_SUPPORT_SSE=1 -msse4.1")
        else()
            set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DBASISU_SUPPORT_SSE=0")
            set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DBASISU_SUPPORT_SSE=0")
        endif()
      
        set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} ${GCC_LINK_FLAGS} -Wl,-rpath .")
    endif()

    set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} ${GCC_COMPILE_FLAGS}")
    set(CMAKE_C_FLAGS_RELEASE  "${CMAKE_C_FLAGS_RELEASE} ${GCC_COMPILE_FLAGS}")
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} ${GCC_COMPILE_FLAGS} -D_DEBUG")

    set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} ${GCC_COMPILE_FLAGS}")
    set(CMAKE_CXX_FLAGS_RELEASE  "${CMAKE_CXX_FLAGS_RELEASE} ${GCC_COMPILE_FLAGS}")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${GCC_COMPILE_FLAGS} -D_DEBUG")
else()
    if (SSE)
        set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DBASISU_SUPPORT_SSE=1")
        set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DBASISU_SUPPORT_SSE=1")
    else()
        set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DBASISU_SUPPORT_SSE=0")
        set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DBASISU_SUPPORT_SSE=0")
    endif()
endif()

# Define the source files for the static library
set(ENCODER_LIB_SRC_LIST
    encoder/basisu_backend.cpp
    encoder/basisu_basis_file.cpp
    encoder/basisu_comp.cpp
    encoder/basisu_enc.cpp
    encoder/basisu_etc.cpp
    encoder/basisu_frontend.cpp
    encoder/basisu_gpu_texture.cpp
    encoder/basisu_pvrtc1_4.cpp
    encoder/basisu_resampler.cpp
    encoder/basisu_resample_filters.cpp
    encoder/basisu_ssim.cpp
    encoder/basisu_uastc_enc.cpp
    encoder/basisu_bc7enc.cpp
    encoder/jpgd.cpp
    encoder/basisu_kernels_sse.cpp
    encoder/basisu_opencl.cpp
    encoder/pvpngreader.cpp
    encoder/basisu_uastc_hdr_4x4_enc.cpp
    encoder/basisu_astc_hdr_6x6_enc.cpp
    encoder/basisu_astc_hdr_common.cpp
    encoder/3rdparty/android_astc_decomp.cpp
    encoder/3rdparty/tinyexr.cpp
    transcoder/basisu_transcoder.cpp
)

if (ZSTD)
    set(ENCODER_LIB_SRC_LIST ${ENCODER_LIB_SRC_LIST} zstd/zstd.c)
endif()

# Create the static library
add_library(basisu_encoder STATIC ${ENCODER_LIB_SRC_LIST})

# Create the basisu executable and link against the static library
add_executable(basisu basisu_tool.cpp)
target_link_libraries(basisu PRIVATE basisu_encoder)

# Create the new example executable and link against the static library
add_executable(examples example/example.cpp)
target_link_libraries(examples PRIVATE basisu_encoder)

if (ZSTD)
    target_compile_definitions(basisu PRIVATE BASISD_SUPPORT_KTX2_ZSTD=1)
    target_compile_definitions(examples PRIVATE BASISD_SUPPORT_KTX2_ZSTD=1)
else()
    target_compile_definitions(basisu PRIVATE BASISD_SUPPORT_KTX2_ZSTD=0)
    target_compile_definitions(examples PRIVATE BASISD_SUPPORT_KTX2_ZSTD=0)
endif()

if (NOT MSVC)
    # For Non-Windows builds, let cmake try and find the system OpenCL headers/libs for us.
    if (OPENCL AND OPENCL_FOUND)
        set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DBASISU_SUPPORT_OPENCL=1")
        set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DBASISU_SUPPORT_OPENCL=1")    
        
        target_include_directories(basisu PRIVATE ${OpenCL_INCLUDE_DIRS})
        target_include_directories(examples PRIVATE ${OpenCL_INCLUDE_DIRS})
		target_include_directories(basisu_encoder PRIVATE ${OpenCL_INCLUDE_DIRS})
        set(BASISU_EXTRA_LIBS ${OpenCL_LIBRARIES})
    endif()
else()
    # For Windows builds, we use our local copies of the OpenCL import lib and Khronos headers.
    if (OPENCL)
        set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DBASISU_SUPPORT_OPENCL=1")
        set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DBASISU_SUPPORT_OPENCL=1")    
        
        target_include_directories(basisu PRIVATE "OpenCL")
        target_include_directories(examples PRIVATE "OpenCL")
		target_include_directories(basisu_encoder PRIVATE "OpenCL")

        if (BUILD_X64)
            target_link_libraries(basisu PRIVATE "${CMAKE_SOURCE_DIR}/OpenCL/lib/OpenCL64.lib")
            target_link_libraries(examples PRIVATE "${CMAKE_SOURCE_DIR}/OpenCL/lib/OpenCL64.lib")
        else()
            target_link_libraries(basisu PRIVATE "${CMAKE_SOURCE_DIR}/OpenCL/lib/OpenCL.lib")
            target_link_libraries(examples PRIVATE "${CMAKE_SOURCE_DIR}/OpenCL/lib/OpenCL.lib")
        endif()
    endif()
endif()    

if (NOT MSVC)
    target_link_libraries(basisu PRIVATE m pthread ${BASISU_EXTRA_LIBS})
    target_link_libraries(examples PRIVATE m pthread ${BASISU_EXTRA_LIBS})
endif()

if (NOT EMSCRIPTEN)
    if (UNIX)
        if (CMAKE_BUILD_TYPE STREQUAL Release)
            if (APPLE)
                add_custom_command(TARGET basisu POST_BUILD COMMAND strip -X -x ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/basisu)
				#message("strip command: strip -X -x ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/basisu")
            else()
                add_custom_command(TARGET basisu POST_BUILD COMMAND strip -g -X -x ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/basisu)
				#message("strip command: strip -g -X -x ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/basisu")
            endif()
        endif()
    endif()
endif()

if (MSVC)
	set_target_properties(basisu PROPERTIES 
        RUNTIME_OUTPUT_NAME "basisu"
        RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        RUNTIME_OUTPUT_DIRECTORY_MINSIZEREL ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    )	
	
	set_target_properties(examples PROPERTIES 
        RUNTIME_OUTPUT_NAME "examples"
        RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        RUNTIME_OUTPUT_DIRECTORY_MINSIZEREL ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    )	
endif()

=== subprojects/sdl3-cmake-wrapper/meson_options.txt ===

option('system_iconv',
    type : 'feature',
    value : 'auto',
    description : 'Use iconv() from system-installed libraries'
)

option('x11',
    type : 'feature',
    value : 'auto',
    description : 'Use X11 video driver'
)

option('wayland',
    type : 'feature',
    value : 'auto',
    description : 'Use Wayland video driver'
)

option('pulseaudio',
    type : 'feature',
    value : 'auto',
    description : 'Use PulseAudio'
)

option('pipewire',
    type : 'feature',
    value : 'auto',
    description : 'Use Pipewire audio'
)

option('alsa',
    type : 'feature',
    value : 'auto',
    description : 'Support the ALSA audio API'
)

option('pthreads',
    type : 'feature',
    value : 'auto',
    description : 'Use POSIX threads for multi-threading'
)

## taisei 1.4.4+dfsg

=== subprojects/mimalloc-cmake-wrapper/meson_options.txt ===
option(
    'secure',
    type : 'feature',
    value : 'auto',
    description : 'Use full security mitigations (like guard pages, allocation randomization, double-free mitigation, and free-list corruption detection)'
)

option(
    'debug_basic',
    type : 'feature',
    value : 'auto',
    description : 'Enable extra debugging features'
)

option(
    'debug_full',
    type : 'feature',
    value : 'auto',
    description : 'Use full internal heap invariant checking in DEBUG mode (expensive)'
)

option(
    'padding',
    type : 'feature',
    value : 'auto',
    description : 'Enable padding to detect heap block overflow (always on in DEBUG or SECURE mode, or with Valgrind/ASAN)'
)

option(
    'override',
    type : 'feature',
    value : 'disabled',
    description : 'Override the standard malloc interface (i.e. define entry points for "malloc", "free", etc)'
)

option(
    'xmalloc',
    type : 'feature',
    value : 'auto',
    description : 'Enable abort() call on memory allocation failure by default'
)

option(
    'show_errors',
    type : 'feature',
    value : 'auto',
    description : 'Show error and warning messages by default (only enabled by default in DEBUG mode)'
)

option(
    'track_valgrind',
    type : 'feature',
    value : 'auto',
    description : 'Compile with Valgrind support (adds a small overhead)'
)

option(
    'track_asan',
    type : 'feature',
    value : 'auto',
    description : 'Compile with address sanitizer support (adds a small overhead)'
)

option(
    'track_etw',
    type : 'feature',
    value : 'auto',
    description : 'Compile with Windows event tracing (ETW) support (adds a small overhead)'
)

option(
    'local_dynamic_tls',
    type : 'feature',
    value : 'auto',
    description : 'Use local-dynamic-tls, a slightly slower but dlopen-compatible thread local storage mechanism (Unix)'
)

option(
    'libc_musl',
    type : 'feature',
    value : 'auto',
    description : 'Set this when linking with musl libc'
)

option(
    'guarded',
    type : 'feature',
    value : 'auto',
    description : 'Build with guard pages behind certain object allocations (implies MI_NO_PADDING=ON)'
)

option(
    'no_padding',
    type : 'feature',
    value : 'auto',
    description : 'Force no use of padding even in DEBUG mode etc.'
)

option(
    'no_thp',
    type : 'feature',
    value : 'auto',
    description : 'Disable transparent huge pages support on Linux/Android for the mimalloc process only'
)

=== external/basis_universal/webgl/encoder/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(basisu_encoder_js)

# The encoder always supports generating KTX2 files, but Zstandard support is optional. If it's disabled, KTX2 UASTC files will always be uncompressed.
# If you know you'll never be encoding UASTC+Zstd KTX2 files you can set KTX2_ZSTANDARD to 0 to reduce the size of the compiled encoder.
option(KTX2_ZSTANDARD "KTX2_ZSTANDARD" TRUE)

message("KTX2_ZSTANDARD=${KTX2_ZSTANDARD}")

if (EMSCRIPTEN)
  set(CMAKE_CXX_STANDARD 17)
  
  set(SRC_LIST
    ../transcoder/basis_wrappers.cpp
    ../../transcoder/basisu_transcoder.cpp
	../../encoder/basisu_backend.cpp                         
	../../encoder/basisu_basis_file.cpp                      
	../../encoder/basisu_comp.cpp                            
	../../encoder/basisu_enc.cpp                             
	../../encoder/basisu_etc.cpp                             
	../../encoder/basisu_frontend.cpp                        
	../../encoder/basisu_gpu_texture.cpp                     
	../../encoder/basisu_pvrtc1_4.cpp                        
	../../encoder/basisu_resampler.cpp                       
	../../encoder/basisu_resample_filters.cpp                
	../../encoder/basisu_ssim.cpp                            
	../../encoder/basisu_uastc_enc.cpp                       
	../../encoder/basisu_bc7enc.cpp
	../../encoder/basisu_kernels_sse.cpp
	../../encoder/basisu_opencl.cpp
	../../encoder/pvpngreader.cpp
	../../encoder/jpgd.cpp                                   
	../../encoder/3rdparty/android_astc_decomp.cpp
   ../../encoder/basisu_uastc_hdr_4x4_enc.cpp
   ../../encoder/basisu_astc_hdr_6x6_enc.cpp
   ../../encoder/basisu_astc_hdr_common.cpp
	../../encoder/3rdparty/tinyexr.cpp
  )

  if (KTX2_ZSTANDARD)
  	set(SRC_LIST ${SRC_LIST}
		../../zstd/zstd.c
	)
	set(ZSTD_DEFINITION BASISD_SUPPORT_KTX2_ZSTD=1)
  else()
  	set(ZSTD_DEFINITION BASISD_SUPPORT_KTX2_ZSTD=0)
  endif()
  
  # No threading version
  add_executable(basis_encoder.js ${SRC_LIST})

  #target_compile_definitions(basis_encoder.js PRIVATE NDEBUG BASISD_SUPPORT_UASTC=1 BASISD_SUPPORT_BC7=1 BASISD_SUPPORT_ATC=0 BASISD_SUPPORT_ASTC_HIGHER_OPAQUE_QUALITY=0 BASISD_SUPPORT_PVRTC2=0 BASISD_SUPPORT_FXT1=0 BASISD_SUPPORT_ETC2_EAC_RG11=0 BASISU_SUPPORT_ENCODING=1 BASISU_SUPPORT_SSE=0 ${ZSTD_DEFINITION} )
  #target_compile_options(basis_encoder.js PRIVATE -fno-strict-aliasing -O3)
  
  #target_compile_definitions(basis_encoder.js PRIVATE DEBUG BASISD_SUPPORT_UASTC=1 BASISD_SUPPORT_BC7=1 BASISD_SUPPORT_ATC=0 BASISD_SUPPORT_ASTC_HIGHER_OPAQUE_QUALITY=0 BASISD_SUPPORT_PVRTC2=0 BASISD_SUPPORT_FXT1=0 BASISD_SUPPORT_ETC2_EAC_RG11=0 BASISU_SUPPORT_ENCODING=1 BASISU_SUPPORT_SSE=0 ${ZSTD_DEFINITION} )
  #target_compile_options(basis_encoder.js PRIVATE -fno-strict-aliasing -g -O1 -fsanitize=undefined -fsanitize=address)
  
  # debug options  
  #target_compile_definitions(basis_encoder.js PRIVATE DEBUG BASISD_SUPPORT_UASTC=1 BASISD_SUPPORT_BC7=1 BASISD_SUPPORT_ATC=0 BASISD_SUPPORT_ASTC_HIGHER_OPAQUE_QUALITY=0 BASISD_SUPPORT_PVRTC2=0 BASISD_SUPPORT_FXT1=0 BASISD_SUPPORT_ETC2_EAC_RG11=0 BASISU_SUPPORT_ENCODING=1 BASISU_SUPPORT_SSE=0 ${ZSTD_DEFINITION} )
  #target_compile_options(basis_encoder.js PRIVATE -fno-strict-aliasing -g -O0)
  
  # release options
  target_compile_definitions(basis_encoder.js PRIVATE NDEBUG BASISD_SUPPORT_UASTC=1 BASISD_SUPPORT_BC7=1 BASISD_SUPPORT_ATC=0 BASISD_SUPPORT_ASTC_HIGHER_OPAQUE_QUALITY=0 BASISD_SUPPORT_PVRTC2=0 BASISD_SUPPORT_FXT1=0 BASISD_SUPPORT_ETC2_EAC_RG11=0 BASISU_SUPPORT_ENCODING=1 BASISU_SUPPORT_SSE=0 ${ZSTD_DEFINITION} )
  target_compile_options(basis_encoder.js PRIVATE -fno-strict-aliasing -O3)
  
  target_include_directories(basis_encoder.js PRIVATE ../../transcoder)

  set_target_properties(basis_encoder.js PROPERTIES
      OUTPUT_NAME "basis_encoder"
      SUFFIX ".js"
	  
     #LINK_FLAGS "--bind -s INITIAL_MEMORY=536870912 -s ALLOW_MEMORY_GROWTH=1 -s STACK_SIZE=262144 -s MODULARIZE=1 -s EXPORT_NAME=BASIS")
	  #LINK_FLAGS "--bind -s INITIAL_MEMORY=536870912 -g -s STACK_SIZE=262144 -s ALLOW_MEMORY_GROWTH=1 -s MODULARIZE=1 -s EXPORT_NAME=BASIS -fsanitize=undefined -fsanitize=address")
	  #LINK_FLAGS "--bind -s INITIAL_MEMORY=536870912 -g -s STACK_SIZE=262144 -s ALLOW_MEMORY_GROWTH=1 -s MODULARIZE=1 -s EXPORT_NAME=BASIS -s ASSERTIONS=2")
  	  LINK_FLAGS "--bind -s ALLOW_MEMORY_GROWTH=1 -s INITIAL_MEMORY=536870912 -s STACK_SIZE=262144 -s MODULARIZE=1 -s EXPORT_NAME=BASIS -s ASSERTIONS=0")

   add_executable(basis_encoder_threads.js ${SRC_LIST})

   # Threaded version   
   target_compile_definitions(basis_encoder_threads.js PRIVATE NDEBUG BASISD_SUPPORT_UASTC=1 BASISD_SUPPORT_BC7=1 BASISD_SUPPORT_ATC=0 BASISD_SUPPORT_ASTC_HIGHER_OPAQUE_QUALITY=0 BASISD_SUPPORT_PVRTC2=0 BASISD_SUPPORT_FXT1=0 BASISD_SUPPORT_ETC2_EAC_RG11=0 BASISU_SUPPORT_ENCODING=1 BASISU_SUPPORT_SSE=0 ${ZSTD_DEFINITION} WASM_THREADS_ENABLED=1 )
   target_include_directories(basis_encoder_threads.js PRIVATE ../../transcoder)   
   
   target_compile_options(basis_encoder_threads.js PRIVATE -fno-strict-aliasing -O3 -matomics -mbulk-memory)   
   
   set_target_properties(basis_encoder_threads.js PROPERTIES
      OUTPUT_NAME "basis_encoder_threads"
      SUFFIX ".js"
     #LINK_FLAGS "--bind -s INITIAL_MEMORY=536870912 -s ALLOW_MEMORY_GROWTH=1 -s STACK_SIZE=262144 -s MODULARIZE=1 -s EXPORT_NAME=BASIS")
	  #LINK_FLAGS "--bind -s INITIAL_MEMORY=536870912 -g -s STACK_SIZE=262144 -s ALLOW_MEMORY_GROWTH=1 -s MODULARIZE=1 -s EXPORT_NAME=BASIS -fsanitize=undefined -fsanitize=address")
	  #LINK_FLAGS "--bind -s INITIAL_MEMORY=536870912 -g -s STACK_SIZE=262144 -s ALLOW_MEMORY_GROWTH=1 -s MODULARIZE=1 -s EXPORT_NAME=BASIS -s ASSERTIONS=2 -s USE_PTHREADS=1 -s PTHREAD_POOL_SIZE=18 -s ENVIRONMENT=web,worker")
  	  LINK_FLAGS "--bind -s ALLOW_MEMORY_GROWTH=1 -s INITIAL_MEMORY=536870912 -s STACK_SIZE=262144 -s MODULARIZE=1 -s EXPORT_NAME=BASIS -s ASSERTIONS=0 -s USE_PTHREADS=1 -s PTHREAD_POOL_SIZE=18 -s ENVIRONMENT=web,worker")

endif()

=== external/basis_universal/webgl/transcoder/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(basisu_transcoder_js)

# KTX2 support (and Zstandard) in the transcoder is purely optional. Use "cmake -DKTX2=FALSE" to completely disable KTX2 support (which also disables Zstandard).
# If this is FALSE you'll only be able to transcode .basis files.
option(KTX2 "KTX2" TRUE)

# If KTX2 is enabled, Zstandard is needed to support decompressing supercompressed UASTC files. 
# If you know you'll never be transcoding KTX2 files using this feature you can set KTX2_ZSTANDARD to 0.
option(KTX2_ZSTANDARD "KTX2_ZSTANDARD" TRUE)

message("KTX2=${KTX2}")
message("KTX2_ZSTANDARD=${KTX2_ZSTANDARD}")

if (EMSCRIPTEN)
  set(CMAKE_CXX_STANDARD 17)
  
  set(SRC_LIST
  	../../transcoder/basisu_transcoder.cpp
	basis_wrappers.cpp
  )
  
  if (KTX2)
	set(KTX2_DEFINITION BASISD_SUPPORT_KTX2=1)
  else()
  	set(KTX2_DEFINITION BASISD_SUPPORT_KTX2=0)
  endif()
  
  if (KTX2_ZSTANDARD)
 	set(SRC_LIST ${SRC_LIST}
		../../zstd/zstddeclib.c
	)
	set(ZSTD_DEFINITION BASISD_SUPPORT_KTX2_ZSTD=1)
  else()
  	set(ZSTD_DEFINITION BASISD_SUPPORT_KTX2_ZSTD=0)
  endif()
  
#  message("KTX2_DEFINITION=${KTX2_DEFINITION})
#  message("ZSTD_DEFINITION=${ZSTD_DEFINITION})

  add_executable(basis_transcoder.js ${SRC_LIST})

  target_compile_definitions(basis_transcoder.js PRIVATE NDEBUG 
  	BASISD_SUPPORT_UASTC_HDR=1 
	BASISD_SUPPORT_UASTC=1 
	BASISD_SUPPORT_BC7=1 
	BASISD_SUPPORT_ATC=0 
	BASISD_SUPPORT_ASTC_HIGHER_OPAQUE_QUALITY=0 
	BASISD_SUPPORT_PVRTC2=0 
	BASISD_SUPPORT_FXT1=0 
	BASISD_SUPPORT_ETC2_EAC_RG11=0 
	BASISU_SUPPORT_ENCODING=0 
	BASISD_ENABLE_DEBUG_FLAGS=1
	${KTX2_DEFINITION} 
	${ZSTD_DEFINITION} 
  )
  
  target_compile_options(basis_transcoder.js PRIVATE -O3 -fno-strict-aliasing)
  #target_compile_options(basis_transcoder.js PRIVATE -O0 -g -fno-strict-aliasing)
      
  target_include_directories(basis_transcoder.js PRIVATE ../../transcoder)

  set_target_properties(basis_transcoder.js PROPERTIES
      OUTPUT_NAME "basis_transcoder"
      SUFFIX ".js"
      LINK_FLAGS "--bind -s ALLOW_MEMORY_GROWTH=1 -s MALLOC=emmalloc -s MODULARIZE=1 -s EXPORT_NAME=BASIS -s ASSERTIONS=0")
endif()

=== debian/changelog ===
taisei (1.4.4+dfsg-3) unstable; urgency=low

  * Update debian/patches/0001_zstd_lower_level_on_lowmem_platforms.patch

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Thu, 14 Aug 2025 11:21:02 +0100

taisei (1.4.4+dfsg-2) unstable; urgency=low

  * Add debian/patches/0001_zstd_lower_level_on_lowmem_platforms.patch:
    Use lower compress level on some platforms to fix FTBFS.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Thu, 14 Aug 2025 06:27:58 +0100

taisei (1.4.4+dfsg-1) unstable; urgency=low

  * New upstream release.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Wed, 13 Aug 2025 13:14:26 +0100

=== debian/control ===
--- 
+++ 
@@ -11,8 +11,7 @@
                libfreetype-dev,
                libopusfile-dev,
                libpng-dev,
-               libsdl2-dev,
-               libsdl2-mixer-dev,
+               libsdl3-dev,
                libssl-dev,
                libwebp-dev,
                libzip-dev,

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# See FEATURE AREAS in dpkg-buildflags(1).
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	--bindir=games

DB2MAN = /usr/share/sgml/docbook/stylesheet/xsl/docbook-xsl/manpages/docbook.xsl
XP     = xsltproc -''-nonet -''-param man.charmap.use.subset "0"

taisei.6: debian/taisei.manpage.xml
	$(XP) $(DB2MAN) $<

execute_after_dh_auto_build: taisei.6

=== debian/watch ===
# Compulsory line, this is a version 4 file.
version=4

GitHub hosted projects.
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%, repacksuffix=+dfsg, dversionmangle=auto, repack,compression=xz" \
    https://github.com/taisei-project/taisei/releases \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
